use crate::{solutions, Problem};
use std::{fs, io};

pub fn run_solution(problem: Problem, in_file: &String, out_file: &String) {
    // parse the input file into a string
    let solution: io::Result<String> = match fs::read_to_string(in_file) {
        Ok(content) => match problem {
            Problem::REVP => Ok(solutions::revp(content)),
        },
        Err(e) => Err(e),
    };

    match solution {
        Ok(out_content) => match fs::write(out_file, &out_content) {
            Ok(_) => println!("{:?}", out_content),
            Err(e) => println!("Error writing to output file: {e}"),
        },
        Err(e) => println!("An error occured reading the input file: {e}"),
    };
}
